

# Setup
To use the Beamtracer with [AudioDice](https://gitlab.com/sat-mtl/tools/audiodice) you must use the HOA decoder goupillon from [metalab-ugens](https://gitlab.com/sat-mtl/metalab/metalab-ugens) (the speakers coordinates are wrong, they have to be changed). You will need to copy the `Platform.userExtensionDir` directory.

## Plugins
You will find 4 plugins : 
- 3 sources plugins
- 1 mapper plugin

### Sources

`sndInDirect`, `sndInRW` and `sndInLW` are 3 alternatives of the Satie's plugin MonoIn. They read a mono source from a bus and apply a delay in function of 3 distances to compensate the unphasing due to the paths difference. Thereby, the listener will listen to the 3 sources in phase.

### Mapper

`beamTracerMapper` is a default mapper that has to be used with the 3 sources plugins defined above.

# BeamTracer
This BeamTracer uses the walls reflections to improve the spatialization of an AudioDice by creating 2 virtuals sources behind the walls.

The script BeamTracer.scd generates one mono file towards 3 directions represendted on the figure below: 
- the direct beam D : the shortest path from the AudioDice (dark blue) to the listener
- the right beam RW : the path from the virtual AudioDice (light blue) behind the right wall to the listener
- the left beam LW : the path from the virtual AudioDice (light blue) behind the left wall to the listener

![beamTracer](./images/BeamTracer.png)

## Parameters

### Positions

You need to define the positions of the AudioDice (dX, dY) and of the listener (lX, lY).

### Source directivity
The aziSource parameter represents the source directivity according to the listener. The source directivity towards the AudioDice (aka the direct beam) is defined as the origin.

The range of the aziSource parameter is defined from -70° to 70°.

### Level

You can adjust the global level with this parameter

## Algorithm

The routine r is actually the algorithm of the BeamTracer. The directivity of the 3 sources are adjusted in function of the AudioDice position, the listener position and the source directivity.

If the source directivity is between the 2 reflections beams (LW and RW) represented by the dark gray area in the figure then the source directivity is generated by adjusting the gain of the three beams like a DBAP method. 

Otherwise, if the source directivity is out of this area represented by the light gray area then only one source is generated toward one of the walls as shown by the dotted line in the figure. 

The gain is also adjusted in function of the distance between the real or virtual AudioDice and the listener. 

## Visualisation

A plotter and two sliders have been created to play with the position of the listener, the source directivity and the the source level and to visualize the position of the AudioDice and of the listener.


## Demo

BeamTracer_Demo.scd is an example that generates 2 mono sources through the BeamTracer algorithm.
You can control the level and the directivity of the first source (a SawBass synth) and you can control the level, the source directivity and the frequency of the second source.